/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.ScriptParamRecord;

import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ScriptParam extends TableImpl<ScriptParamRecord> {

	private static final long serialVersionUID = -391625178;

	/**
	 * The reference instance of <code>public.script_param</code>
	 */
	public static final ScriptParam SCRIPT_PARAM = new ScriptParam();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<ScriptParamRecord> getRecordType() {
		return ScriptParamRecord.class;
	}

	/**
	 * The column <code>public.script_param.id</code>.
	 */
	public final TableField<ScriptParamRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.script_param.script_instance_id</code>.
	 */
	public final TableField<ScriptParamRecord, Long> SCRIPT_INSTANCE_ID = createField("script_instance_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

	/**
	 * The column <code>public.script_param.script_param_def_id</code>.
	 */
	public final TableField<ScriptParamRecord, Long> SCRIPT_PARAM_DEF_ID = createField("script_param_def_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

	/**
	 * The column <code>public.script_param.value</code>.
	 */
	public final TableField<ScriptParamRecord, byte[]> VALUE = createField("value", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * Create a <code>public.script_param</code> table reference
	 */
	public ScriptParam() {
		this("script_param", null);
	}

	/**
	 * Create an aliased <code>public.script_param</code> table reference
	 */
	public ScriptParam(String alias) {
		this(alias, SCRIPT_PARAM);
	}

	private ScriptParam(String alias, Table<ScriptParamRecord> aliased) {
		this(alias, aliased, null);
	}

	private ScriptParam(String alias, Table<ScriptParamRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<ScriptParamRecord, Long> getIdentity() {
		return Keys.IDENTITY_SCRIPT_PARAM;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<ScriptParamRecord> getPrimaryKey() {
		return Keys.SCRIPT_PARAM_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<ScriptParamRecord>> getKeys() {
		return Arrays.<UniqueKey<ScriptParamRecord>>asList(Keys.SCRIPT_PARAM_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<ForeignKey<ScriptParamRecord, ?>> getReferences() {
		return Arrays.<ForeignKey<ScriptParamRecord, ?>>asList(Keys.SCRIPT_PARAM__SCRIPT_PARAM_SCRIPT_INSTANCE_ID_FKEY, Keys.SCRIPT_PARAM__SCRIPT_PARAM_SCRIPT_PARAM_DEF_ID_FKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParam as(String alias) {
		return new ScriptParam(alias, this);
	}

	/**
	 * Rename this table
	 */
	public ScriptParam rename(String name) {
		return new ScriptParam(name, null);
	}
}
